<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLApiMessage&lt; DATA_TYPE, ID_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLApiMessage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLApiMessage&lt; DATA_TYPE, ID_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core data message class definition.  
 <a href="classTIGLApiMessage.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglApiMessage_8hpp_source.html">tiglApiMessage.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1bcf230cbd34f3ea11b0a19e6e8c46bb"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a1bcf230cbd34f3ea11b0a19e6e8c46bb">TIGLApiMessage</a> ()</td></tr>
<tr class="memdesc:a1bcf230cbd34f3ea11b0a19e6e8c46bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Empty constructor.  <a href="#a1bcf230cbd34f3ea11b0a19e6e8c46bb">More...</a><br /></td></tr>
<tr class="separator:a1bcf230cbd34f3ea11b0a19e6e8c46bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2326c4d03d9ebc5ca0b0d5d2bcc907d9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a2326c4d03d9ebc5ca0b0d5d2bcc907d9">TIGLApiMessage</a> (ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</td></tr>
<tr class="memdesc:a2326c4d03d9ebc5ca0b0d5d2bcc907d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor of a message with all fields.  <a href="#a2326c4d03d9ebc5ca0b0d5d2bcc907d9">More...</a><br /></td></tr>
<tr class="separator:a2326c4d03d9ebc5ca0b0d5d2bcc907d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a371c566746c5bbfa8e8d23e8f9c0f8a8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a371c566746c5bbfa8e8d23e8f9c0f8a8"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a371c566746c5bbfa8e8d23e8f9c0f8a8">~TIGLApiMessage</a> ()</td></tr>
<tr class="memdesc:a371c566746c5bbfa8e8d23e8f9c0f8a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a371c566746c5bbfa8e8d23e8f9c0f8a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9369fd796d383a32d5da1dfdbf03029"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa9369fd796d383a32d5da1dfdbf03029"></a>
ID_TYPE &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#aa9369fd796d383a32d5da1dfdbf03029">getSender</a> ()</td></tr>
<tr class="memdesc:aa9369fd796d383a32d5da1dfdbf03029"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the sender vertex. <br /></td></tr>
<tr class="separator:aa9369fd796d383a32d5da1dfdbf03029"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7b2bcd6adc37bfa481140578e0ea62e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae7b2bcd6adc37bfa481140578e0ea62e"></a>
ID_TYPE &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#ae7b2bcd6adc37bfa481140578e0ea62e">getRcvr</a> ()</td></tr>
<tr class="memdesc:ae7b2bcd6adc37bfa481140578e0ea62e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the destination vertex. <br /></td></tr>
<tr class="separator:ae7b2bcd6adc37bfa481140578e0ea62e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b0a1ee1c93f1aa3cc549d5302ce96f8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5b0a1ee1c93f1aa3cc549d5302ce96f8"></a>
DATA_TYPE &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a5b0a1ee1c93f1aa3cc549d5302ce96f8">getContent</a> ()</td></tr>
<tr class="memdesc:a5b0a1ee1c93f1aa3cc549d5302ce96f8"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the message content <br /></td></tr>
<tr class="separator:a5b0a1ee1c93f1aa3cc549d5302ce96f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1035677b3c041d84722ebcee934494c8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a1035677b3c041d84722ebcee934494c8">setMessage</a> (ID_TYPE &amp;tx, ID_TYPE &amp;rx, DATA_TYPE &amp;messContent)</td></tr>
<tr class="memdesc:a1035677b3c041d84722ebcee934494c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the full message fields.  <a href="#a1035677b3c041d84722ebcee934494c8">More...</a><br /></td></tr>
<tr class="separator:a1035677b3c041d84722ebcee934494c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a759de6881a25aa38cbf86061b822303d"><td class="memTemplParams" colspan="2">template&lt;typename CMessages &gt; </td></tr>
<tr class="memitem:a759de6881a25aa38cbf86061b822303d"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a759de6881a25aa38cbf86061b822303d">setMessage</a> (CMessages &amp;newMessage)</td></tr>
<tr class="memdesc:a759de6881a25aa38cbf86061b822303d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copies from another message.  <a href="#a759de6881a25aa38cbf86061b822303d">More...</a><br /></td></tr>
<tr class="separator:a759de6881a25aa38cbf86061b822303d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f9439bfa1e4d00c52b57262c86cfe5c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a2f9439bfa1e4d00c52b57262c86cfe5c">setContent</a> (DATA_TYPE &amp;newContent)</td></tr>
<tr class="memdesc:a2f9439bfa1e4d00c52b57262c86cfe5c"><td class="mdescLeft">&#160;</td><td class="mdescRight">set the message content  <a href="#a2f9439bfa1e4d00c52b57262c86cfe5c">More...</a><br /></td></tr>
<tr class="separator:a2f9439bfa1e4d00c52b57262c86cfe5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af73d429f62ed6755919596dfe5327bf0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#af73d429f62ed6755919596dfe5327bf0">sumContent</a> (DATA_TYPE &amp;newContent)</td></tr>
<tr class="memdesc:af73d429f62ed6755919596dfe5327bf0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sums new content to the current message content.  <a href="#af73d429f62ed6755919596dfe5327bf0">More...</a><br /></td></tr>
<tr class="separator:af73d429f62ed6755919596dfe5327bf0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a521939564e210bb83a38bc6e27c1ab4c"><td class="memTemplParams" colspan="2">template&lt;typename CMessages &gt; </td></tr>
<tr class="memitem:a521939564e210bb83a38bc6e27c1ab4c"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a521939564e210bb83a38bc6e27c1ab4c">maxContent</a> (CMessages &amp;newMessage)</td></tr>
<tr class="memdesc:a521939564e210bb83a38bc6e27c1ab4c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copies a new message content if its value is bigger than the current message content.  <a href="#a521939564e210bb83a38bc6e27c1ab4c">More...</a><br /></td></tr>
<tr class="separator:a521939564e210bb83a38bc6e27c1ab4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca36b71d7530df34480482b909c5bd95"><td class="memTemplParams" colspan="2">template&lt;typename CMessages &gt; </td></tr>
<tr class="memitem:aca36b71d7530df34480482b909c5bd95"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#aca36b71d7530df34480482b909c5bd95">minContent</a> (CMessages &amp;newMessage)</td></tr>
<tr class="memdesc:aca36b71d7530df34480482b909c5bd95"><td class="mdescLeft">&#160;</td><td class="mdescRight">copy a new message content if its value is smaller than the current message content  <a href="#aca36b71d7530df34480482b909c5bd95">More...</a><br /></td></tr>
<tr class="separator:aca36b71d7530df34480482b909c5bd95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f179078ae75d7fc8523a99584c960ab"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a1f179078ae75d7fc8523a99584c960ab">pack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:a1f179078ae75d7fc8523a99584c960ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Packs the content of the message to a uint8_t buffer. It is organized as : rcvr, sender, content.  <a href="#a1f179078ae75d7fc8523a99584c960ab">More...</a><br /></td></tr>
<tr class="separator:a1f179078ae75d7fc8523a99584c960ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7c907cb28b7976f0dc8e1039a789b9b"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#af7c907cb28b7976f0dc8e1039a789b9b">unpack</a> (uint8_t *buf)</td></tr>
<tr class="memdesc:af7c907cb28b7976f0dc8e1039a789b9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unpacks a packed message to get the message.  <a href="#af7c907cb28b7976f0dc8e1039a789b9b">More...</a><br /></td></tr>
<tr class="separator:af7c907cb28b7976f0dc8e1039a789b9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a67ac68852a43eb8503f43c497ac8f6cd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a67ac68852a43eb8503f43c497ac8f6cd"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a67ac68852a43eb8503f43c497ac8f6cd">sizeInBytes</a> ()</td></tr>
<tr class="memdesc:a67ac68852a43eb8503f43c497ac8f6cd"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns message size in bytes <br /></td></tr>
<tr class="separator:a67ac68852a43eb8503f43c497ac8f6cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a4424f2bddf5ccd38e2dac18a1f067e2f"><td class="memItemLeft" align="right" valign="top">ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a4424f2bddf5ccd38e2dac18a1f067e2f">sender</a></td></tr>
<tr class="separator:a4424f2bddf5ccd38e2dac18a1f067e2f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7968fe46245001626ec18c95b15ff6b6"><td class="memItemLeft" align="right" valign="top">ID_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#a7968fe46245001626ec18c95b15ff6b6">rcvr</a></td></tr>
<tr class="separator:a7968fe46245001626ec18c95b15ff6b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7f775baa649862450e48448fabf97ae"><td class="memItemLeft" align="right" valign="top">DATA_TYPE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLApiMessage.html#ae7f775baa649862450e48448fabf97ae">content</a></td></tr>
<tr class="separator:ae7f775baa649862450e48448fabf97ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DATA_TYPE, typename ID_TYPE = uint_fast32_t&gt;<br />
class TIGLApiMessage&lt; DATA_TYPE, ID_TYPE &gt;</h3>

<p>Core data message class definition. </p>
<p>It handles all the data message fields and processing It is a template class that is parameterized by </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DATA_TYPE</td><td>the data field of the message </td></tr>
    <tr><td class="paramname">ID_TYPE</td><td>the type of the rx/tx vertex id </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a1bcf230cbd34f3ea11b0a19e6e8c46bb"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::<a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Empty constructor. </p>
<p>Message fields have to be filled using public methods </p>

</div>
</div>
<a class="anchor" id="a2326c4d03d9ebc5ca0b0d5d2bcc907d9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::<a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a> </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>rx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>messContent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor of a message with all fields. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tx</td><td>the sender vertex </td></tr>
    <tr><td class="paramname">rx</td><td>the receiver vertex </td></tr>
    <tr><td class="paramname">messContent</td><td>the message body </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a521939564e210bb83a38bc6e27c1ab4c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename CMessages &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::maxContent </td>
          <td>(</td>
          <td class="paramtype">CMessages &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Copies a new message content if its value is bigger than the current message content. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the other messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aca36b71d7530df34480482b909c5bd95"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename CMessages &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::minContent </td>
          <td>(</td>
          <td class="paramtype">CMessages &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>copy a new message content if its value is smaller than the current message content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the other messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1f179078ae75d7fc8523a99584c960ab"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::pack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Packs the content of the message to a uint8_t buffer. It is organized as : rcvr, sender, content. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>a uint8_t buffer that will have the packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size of the packed message in bytes. </dd></dl>

</div>
</div>
<a class="anchor" id="a2f9439bfa1e4d00c52b57262c86cfe5c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::setContent </td>
          <td>(</td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newContent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>set the message content </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newContent</td><td>the new message content </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1035677b3c041d84722ebcee934494c8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::setMessage </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>rx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>messContent</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the full message fields. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">tx</td><td>the sender vertex </td></tr>
    <tr><td class="paramname">rx</td><td>the receiver vertex </td></tr>
    <tr><td class="paramname">messContent</td><td>the message body </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a759de6881a25aa38cbf86061b822303d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename CMessages &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::setMessage </td>
          <td>(</td>
          <td class="paramtype">CMessages &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Copies from another message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the other messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af73d429f62ed6755919596dfe5327bf0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::sumContent </td>
          <td>(</td>
          <td class="paramtype">DATA_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newContent</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sums new content to the current message content. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newContent</td><td>the new message content (to be summed with the current message value) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af7c907cb28b7976f0dc8e1039a789b9b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::unpack </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>buf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Unpacks a packed message to get the message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buf</td><td>a uint8_t buffer that has the packed message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the size of the packed message in bytes. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="ae7f775baa649862450e48448fabf97ae"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE  = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">DATA_TYPE <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::content</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">the</td><td>message body </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7968fe46245001626ec18c95b15ff6b6"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE  = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ID_TYPE <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::rcvr</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">the</td><td>receiver vertex </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4424f2bddf5ccd38e2dac18a1f067e2f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DATA_TYPE , typename ID_TYPE  = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ID_TYPE <a class="el" href="classTIGLApiMessage.html">TIGLApiMessage</a>&lt; DATA_TYPE, ID_TYPE &gt;::sender</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">the</td><td>sender vertex </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglApiMessage_8hpp_source.html">tiglApiMessage.hpp</a></li>
<li><a class="el" href="tiglImplementationMessage_8hpp_source.html">tiglImplementationMessage.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:55 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
